diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/callback-test-suite.cc ns-3.36/src/core/test/callback-test-suite.cc
--- ns-3.35/src/core/test/callback-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/callback-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -18,14 +18,26 @@
 
 #include "ns3/test.h"
 #include "ns3/callback.h"
-#include "ns3/unused.h"
 #include <stdint.h>
 
 using namespace ns3;
 
-// ===========================================================================
-// Test the basic Callback mechanism
-// ===========================================================================
+/**
+ * \file
+ * \ingroup callback-tests
+ * Callback test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup callback-tests Callback tests
+ */
+
+/**
+ * \ingroup callback-tests
+ * 
+ * Test the basic Callback mechanism.
+ */
 class BasicCallbackTestCase : public TestCase
 {
 public:
@@ -33,24 +45,38 @@
   virtual ~BasicCallbackTestCase ()
   {}
 
+  /**
+   * Callback 1 target function.
+   */
   void Target1 (void)
   {
     m_test1 = true;
   }
+  /**
+   * Callback 2 target function.
+   * \return two.
+   */
   int Target2 (void)
   {
     m_test2 = true;
     return 2;
   }
-  void Target3 (double a)
+  /**
+   * Callback 3 target function.
+   * \param a A parameter (unused).
+   */
+  void Target3 ([[maybe_unused]] double a)
   {
-    NS_UNUSED (a);
     m_test3 = true;
   }
-  int Target4 (double a, int b)
+  /**
+   * Callback 4 target function.
+   * \param a A parameter (unused).
+   * \param b Another parameter (unused).
+   * \return four.
+   */
+  int Target4 ([[maybe_unused]] double a, [[maybe_unused]] int b)
   {
-    NS_UNUSED (a);
-    NS_UNUSED (b);
     m_test4 = true;
     return 4;
   }
@@ -59,28 +85,44 @@
   virtual void DoRun (void);
   virtual void DoSetup (void);
 
-  bool m_test1;
-  bool m_test2;
-  bool m_test3;
-  bool m_test4;
+  bool m_test1; //!< true if Target1 has been called, false otherwise.
+  bool m_test2; //!< true if Target2 has been called, false otherwise.
+  bool m_test3; //!< true if Target3 has been called, false otherwise.
+  bool m_test4; //!< true if Target4 has been called, false otherwise.
 };
 
+/**
+ * Variable to verify that a calback has been called.
+ * @{
+ */
 static bool gBasicCallbackTest5;
 static bool gBasicCallbackTest6;
 static bool gBasicCallbackTest7;
+/** @} */
 
+/**
+ * Callback 5 target function.
+ */
 void
 BasicCallbackTarget5 (void)
 {
   gBasicCallbackTest5 = true;
 }
 
+/**
+ * Callback 6 target function.
+ */
 void
 BasicCallbackTarget6 (int)
 {
   gBasicCallbackTest6 = true;
 }
 
+/**
+ * Callback 6 target function.
+ * \param a The value passed by the callback.
+ * \return the value of the calling function.
+ */
 int
 BasicCallbackTarget7 (int a)
 {
@@ -170,9 +212,11 @@
   NS_TEST_ASSERT_MSG_EQ (gBasicCallbackTest7, true, "Callback did not fire");
 }
 
-// ===========================================================================
-// Test the MakeCallback mechanism
-// ===========================================================================
+/**
+ * \ingroup callback-tests
+ * 
+ * Test the MakeCallback mechanism.
+ */
 class MakeCallbackTestCase : public TestCase
 {
 public:
@@ -180,24 +224,38 @@
   virtual ~MakeCallbackTestCase ()
   {}
 
+  /**
+   * Callback 1 target function.
+   */
   void Target1 (void)
   {
     m_test1 = true;
   }
+  /**
+   * Callback 2 target function.
+   * \return two.
+   */
   int Target2 (void)
   {
     m_test2 = true;
     return 2;
   }
-  void Target3 (double a)
+  /**
+   * Callback 3 target function.
+   * \param a A parameter (unused).
+   */
+  void Target3 ([[maybe_unused]] double a)
   {
-    NS_UNUSED (a);
     m_test3 = true;
   }
-  int Target4 (double a, int b)
+  /**
+   * Callback 4 target function.
+   * \param a A parameter (unused).
+   * \param b Another parameter (unused).
+   * \return four.
+   */
+  int Target4 ([[maybe_unused]] double a, [[maybe_unused]] int b)
   {
-    NS_UNUSED (a);
-    NS_UNUSED (b);
     m_test4 = true;
     return 4;
   }
@@ -206,28 +264,44 @@
   virtual void DoRun (void);
   virtual void DoSetup (void);
 
-  bool m_test1;
-  bool m_test2;
-  bool m_test3;
-  bool m_test4;
+  bool m_test1; //!< true if Target1 has been called, false otherwise.
+  bool m_test2; //!< true if Target2 has been called, false otherwise.
+  bool m_test3; //!< true if Target3 has been called, false otherwise.
+  bool m_test4; //!< true if Target4 has been called, false otherwise.
 };
 
+/**
+ * Variable to verify that a calback has been called.
+ * @{
+ */
 static bool gMakeCallbackTest5;
 static bool gMakeCallbackTest6;
 static bool gMakeCallbackTest7;
+/** @} */
 
+/**
+ * MakeCallback 5 target function.
+ */
 void
 MakeCallbackTarget5 (void)
 {
   gMakeCallbackTest5 = true;
 }
 
+/**
+ * MakeCallback 6 target function.
+ */
 void
 MakeCallbackTarget6 (int)
 {
   gMakeCallbackTest6 = true;
 }
 
+/**
+ * MakeCallback 7 target function.
+ * \param a The value passed by the callback.
+ * \return the value of the calling function.
+ */
 int
 MakeCallbackTarget7 (int a)
 {
@@ -317,9 +391,11 @@
   NS_TEST_ASSERT_MSG_EQ (gMakeCallbackTest7, true, "Callback did not fire");
 }
 
-// ===========================================================================
-// Test the MakeBoundCallback mechanism
-// ===========================================================================
+/**
+ * \ingroup callback-tests
+ * 
+ * Test the MakeBoundCallback mechanism.
+ */
 class MakeBoundCallbackTestCase : public TestCase
 {
 public:
@@ -332,6 +408,10 @@
   virtual void DoSetup (void);
 };
 
+/**
+ * Variable to verify that a calback has been called.
+ * @{
+ */
 static int gMakeBoundCallbackTest1;
 static bool *gMakeBoundCallbackTest2;
 static bool *gMakeBoundCallbackTest3a;
@@ -354,19 +434,36 @@
 static int gMakeBoundCallbackTest9b;
 static int gMakeBoundCallbackTest9c;
 static int gMakeBoundCallbackTest9d;
+/** @} */
 
+// Note: doxygen compounds don not work due to params / return variability.
+
+/**
+ * MakeBoundCallback 1 target function.
+ * \param a The value passed by the callback.
+ */
 void
 MakeBoundCallbackTarget1 (int a)
 {
   gMakeBoundCallbackTest1 = a;
 }
 
+/**
+ * MakeBoundCallback 2 target function.
+ * \param a The value passed by the callback.
+ */
 void
 MakeBoundCallbackTarget2 (bool *a)
 {
   gMakeBoundCallbackTest2 = a;
 }
 
+/**
+ * MakeBoundCallback 3 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \return the value 1234.
+ */
 int
 MakeBoundCallbackTarget3 (bool *a, int b)
 {
@@ -375,6 +472,11 @@
   return 1234;
 }
 
+/**
+ * MakeBoundCallback 4 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ */
 void
 MakeBoundCallbackTarget4 (int a, int b)
 {
@@ -382,6 +484,12 @@
   gMakeBoundCallbackTest4b = b;
 }
 
+/**
+ * MakeBoundCallback 5 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \return the value 1234.
+ */
 int
 MakeBoundCallbackTarget5 (int a, int b)
 {
@@ -390,6 +498,13 @@
   return 1234;
 }
 
+/**
+ * MakeBoundCallback 5 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \param c The value passed by the callback.
+ * \return the value 1234.
+ */
 int
 MakeBoundCallbackTarget6 (int a, int b, int c)
 {
@@ -399,6 +514,12 @@
   return 1234;
 }
 
+/**
+ * MakeBoundCallback 7 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \param c The value passed by the callback.
+ */
 void
 MakeBoundCallbackTarget7 (int a, int b, int c)
 {
@@ -407,6 +528,13 @@
   gMakeBoundCallbackTest7c = c;
 }
 
+/**
+ * MakeBoundCallback 8 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \param c The value passed by the callback.
+ * \return the value 1234.
+ */
 int
 MakeBoundCallbackTarget8 (int a, int b, int c)
 {
@@ -416,6 +544,14 @@
   return 1234;
 }
 
+/**
+ * MakeBoundCallback 5 target function.
+ * \param a The value passed by the callback.
+ * \param b The value passed by the callback.
+ * \param c The value passed by the callback.
+ * \param d The value passed by the callback.
+ * \return the value 1234.
+ */
 int
 MakeBoundCallbackTarget9 (int a, int b, int c, int d)
 {
@@ -545,9 +681,11 @@
   NS_TEST_ASSERT_MSG_EQ (gMakeBoundCallbackTest9d, 5678, "Callback did not fire or binding not correct");
 }
 
-// ===========================================================================
-// Test the Nullify mechanism
-// ===========================================================================
+/**
+ * \ingroup callback-tests
+ * 
+ * Test the Nullify mechanism.
+ */
 class NullifyCallbackTestCase : public TestCase
 {
 public:
@@ -555,6 +693,9 @@
   virtual ~NullifyCallbackTestCase ()
   {}
 
+  /**
+   * Callback 1 target function.
+   */
   void Target1 (void)
   {
     m_test1 = true;
@@ -564,7 +705,7 @@
   virtual void DoRun (void);
   virtual void DoSetup (void);
 
-  bool m_test1;
+  bool m_test1; //!< true if Target1 has been called, false otherwise.
 };
 
 NullifyCallbackTestCase::NullifyCallbackTestCase ()
@@ -595,10 +736,12 @@
   NS_TEST_ASSERT_MSG_EQ (target1.IsNull (), true, "Nullified Callback reports not IsNull()");
 }
 
-// ===========================================================================
-// Make sure that various MakeCallback template functions compile and execute.
-// Doesn't check an results of the execution.
-// ===========================================================================
+/**
+ * \ingroup callback-tests
+ * 
+ * Make sure that various MakeCallback template functions compile and execute;
+ * doesn't check an results of the execution.
+ */
 class MakeCallbackTemplatesTestCase : public TestCase
 {
 public:
@@ -606,6 +749,9 @@
   virtual ~MakeCallbackTemplatesTestCase ()
   {}
 
+  /**
+   * Callback 1 target function.
+   */
   void Target1 (void)
   {
     m_test1 = true;
@@ -614,10 +760,14 @@
 private:
   virtual void DoRun (void);
 
-  bool m_test1;
+  bool m_test1; //!< true if Target1 has been called, false otherwise.
 };
 
 /* *NS_CHECK_STYLE_OFF* */
+/**
+ * Test function - does nothing.
+ * @{
+ */
 void TestFZero (void) {}
 void TestFOne (int) {}
 void TestFTwo (int, int) {}
@@ -632,29 +782,50 @@
 void TestFRFour (int &, int &, int &, int &) {}
 void TestFRFive (int &, int &, int &, int &, int &) {}
 void TestFRSix (int &, int &, int &, int &, int &, int &) {}
+/** @} */
 /* *NS_CHECK_STYLE_ON* */
 
+/**
+ * \ingroup callback-tests
+ * 
+ * Class used to check the capability of callbacks to call 
+ * public, protected, and private functions.
+ */
 class CallbackTestParent
 {
 public:
+  /// A public function.
   void PublicParent (void)
   {}
 
 protected:
+  /// A protected function.
   void ProtectedParent (void)
   {}
+  /// A static protected function.
   static void StaticProtectedParent (void)
   {}
 
 private:
+  /// A private function.
   void PrivateParent (void)
   {}
 };
 
+/**
+ * \ingroup callback-tests
+ * 
+ * Derived class used to check the capability of callbacks to call 
+ * public, protected, and private functions.
+ */
 class CallbackTestClass : public CallbackTestParent
 {
 public:
   /* *NS_CHECK_STYLE_OFF* */
+  /**
+   * Test function - does nothing.
+   * @{
+   */
   void TestZero (void) {}
   void TestOne (int) {}
   void TestTwo (int, int) {}
@@ -669,8 +840,13 @@
   void TestCFour (int, int, int, int) const {}
   void TestCFive (int, int, int, int, int) const {}
   void TestCSix (int, int, int, int, int, int) const {}
+  /** @} */
   /* *NS_CHECK_STYLE_ON* */
 
+  /**
+   * Tries to make a callback to public and protected functions of a class.
+   * Private are not tested because, as expected, the compilation fails.
+   */
   void CheckParentalRights (void)
   {
     MakeCallback (&CallbackTestParent::StaticProtectedParent);
@@ -678,7 +854,10 @@
     MakeCallback (&CallbackTestClass::ProtectedParent, this);
     // as expected, fails.
     // MakeCallback (&CallbackTestParent::PrivateParent, this);
-    // unexpected, but fails too.  It does fumble me.
+    // as expected, fails.
+    // Pointers do not carry the access restriction info, so it is forbidden
+    // to generate a pointer to a parent's protected function, because
+    // this could lead to un-protect them, e.g., by making it public.
     // MakeCallback (&CallbackTestParent::ProtectedParent, this);
   }
 
@@ -739,9 +918,11 @@
   that.CheckParentalRights ();
 }
 
-// ===========================================================================
-// The Test Suite that glues all of the Test Cases together.
-// ===========================================================================
+/**
+ * \ingroup callback-tests
+ *  
+ * \brief The callback Test Suite.
+ */
 class CallbackTestSuite : public TestSuite
 {
 public:
@@ -758,4 +939,4 @@
   AddTestCase (new MakeCallbackTemplatesTestCase, TestCase::QUICK);
 }
 
-static CallbackTestSuite CallbackTestSuite;
+static CallbackTestSuite g_gallbackTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/config-test-suite.cc ns-3.36/src/core/test/config-test-suite.cc
--- ns-3.35/src/core/test/config-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/config-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -30,7 +30,6 @@
 #include "ns3/names.h"
 #include "ns3/pointer.h"
 #include "ns3/log.h"
-#include "ns3/unused.h"
 
 
 #include <sstream>
@@ -235,11 +234,6 @@
 
 private:
   int8_t m_x; //!< X attribute target.
-  /** Silence unused variable warning. */
-  void Increment (void)
-  {
-    m_x++;
-  }
 };
 
 TypeId
@@ -633,9 +627,8 @@
    * \param oldValue The old value.
    * \param newValue The new value.
    */
-  void Trace (int16_t oldValue, int16_t newValue)
+  void Trace ([[maybe_unused]] int16_t oldValue, int16_t newValue)
   {
-    NS_UNUSED (oldValue);
     m_newValue = newValue;
   }
   /**
@@ -644,9 +637,8 @@
    * \param old The old value.
    * \param newValue The new value.
    */
-  void TraceWithPath (std::string path, int16_t old, int16_t newValue)
+  void TraceWithPath (std::string path, [[maybe_unused]] int16_t old, int16_t newValue)
   {
-    NS_UNUSED (old);
     m_newValue = newValue;
     m_path = path;
   }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/core-example-simulator.reflog ns-3.36/src/core/test/core-example-simulator.reflog
--- ns-3.35/src/core/test/core-example-simulator.reflog	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/core-example-simulator.reflog	2022-04-30 18:23:57.802733200 -0700
@@ -1,3 +1,4 @@
 ExampleFunction received event at 10s
 RandomFunction received event at 18.1653s
 Member method received event at 20s started at 10s
+Code within a lambda expression at time +25s
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/test/examples-as-tests-test-suite.cc ns-3.36/src/core/test/examples-as-tests-test-suite.cc
--- ns-3.35/src/core/test/examples-as-tests-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/test/examples-as-tests-test-suite.cc	2022-04-30 18:23:57.802733200 -0700
@@ -27,7 +27,6 @@
 
 /**
  * \file
- * \ingroup core-tests
  * \ingroup examples-as-tests
  * Examples-as-tests test suite
  */
@@ -59,7 +58,14 @@
    */
   virtual ~CommandLineExampleTestCase();
 
-  //Inherited function
+  /**
+  * Override this function to filter the version string from
+  * the command-line-example output.
+  * Since the version changes each time a commit is made it shouldn't
+  * be tested as part of the command-line-example output.
+  * 
+  * \returns The string of post-processing commands.
+  */
   virtual std::string GetPostProcessingCommand (void) const;
 };
 
@@ -72,12 +78,6 @@
 CommandLineExampleTestCase::~CommandLineExampleTestCase ()
 {}
 
-/**
- * Override this function to filter the version string from
- * the command-line-example output.
- * Since the version changes each time a commit is made it shouldn't
- * be tested as part of the command-line-example output
- */
 std::string
 CommandLineExampleTestCase::GetPostProcessingCommand (void) const
 {
